library string2tree_object_dumper;

class ObjectDumper {
	static String dumpObject(Object ob ,[int ind]) {
		if (ind == null)
			ind = 0;
		String s = "";
		if (ob is Map) {
			ob.forEach((String k,Object v) {
				s += _dumpElement(k,v,ind);
			});
		} else if (ob is List) {
			int idx = 0;
			ob.forEach((Object v) {
				s += _dumpElement((idx++).toString(),v,ind);
			});
		} else {
			s += _dumpIndent(ind);
			s += ob.toString()+"\n";
		}
		return s;
	}
	static String _dumpElement(k,v,ind) {
		String s = "";
		s += _dumpIndent(ind);
		s += k+":\n";
		s += dumpObject(v,ind+1);
		return s;
	}
	static String _dumpIndent(ind) {
		String s="";
		for (int i = 0;i<ind*2;++i) 
			s += " ";
		return s;
	}

}