// for publish ~/dart/dart-sdk/bin/pub publish --dry-run
library string2tree;

part "src/tokenize.dart";
part "src/apostrophe_quote.dart";

class Parser {
	String _s;
	List _l = new List();
	List get result => _l;
	Parser(this._s) {
		_Tokenize.execute(this);
	}
	void _nest(int start,int end,int id) {
		Map nest = new Map();
		nest["type"] = id;
		nest["start"] = _l[start]["start"];
		nest["end"] = _l[end]["end"];
		nest["children"] = new List();
		for (int i=start;i<=end;++i) {
			nest["children"].add(_l[i]);
		}
		_l.removeRange(start,end+1);
		_l.insert(start,nest);
	}
	Parser apostropheQuote(int id) {
		_ApostropheQuote.execute(this,id);
		return this;
	}
}