@TestOn("vm")

import "package:test/test.dart";
import "package:string2tree/string2tree.dart" as s2t;
import "package:string2tree/object_dumper.dart";

void main() {
	group("ApostropheQuote -",() {
		setUp(() async {
		});
		tearDown(() async {
		});
		test("single quote", () async {
			List r = new s2t.Parser("this is 'a special test' of single quote").apostropheQuote(-1).result;
			expect(r.length,11);
			expect(r[4]["start"],8);
			expect(r[4]["end"],23);
			expect(r[4]["type"],-1);
			expect(r[4]["children"].length,7);
		});
		test("three quotes", () async {
			List r = new s2t.Parser("this is 'a special test' of '' single 'quote'").apostropheQuote(-1).result;
			expect(r.length,13);
			expect(r[4]["start"],8);
			expect(r[4]["end"],23);
			expect(r[4]["type"],-1);
			expect(r[4]["children"].length,7);
			expect(r[8]["start"],28);
			expect(r[8]["end"],29);
			expect(r[8]["type"],-1);
			expect(r[8]["children"].length,2);
			expect(r[12]["start"],38);
			expect(r[12]["end"],44);
			expect(r[12]["type"],-1);
			expect(r[12]["children"].length,3);
		});
	});
}